import std.math;

import Vec3D;

class Camera{
  double fovy=30.0 ;
  vec3D  eye ;
  vec3D  cnt ;
  vec3D  rot ;
  vec3D  pan ;
  double zoom=1.0 ;
  double zoom_speed=0.08 ;
  double rot_speed =1.0 ;
  vec3D  geyepos ;
  vec3D  geyeray ;

  int    win_w, win_h ;

  vec3D  frray, toray ;
  vec3D  cursor3D ;

  this(){
    reset() ;
  }

  void reset(){
    eye.set( 0.0, 0.0, 10.0) ;
    cnt.set( 0.0, 0.0,  0.0) ;
    rot.set( 0.0, 0.0,  0.0) ;
    pan.set( 0.0, 0.0,  0.0) ;
  }

  double addRotX(double d){
    rot.x += d*rot_speed ;
    if( rot.x<  0.0 ) rot.x+=360.0 ;
    if( rot.x>360.0 ) rot.x-=360.0 ;
    return(rot.x) ;
  }

  double addRotY(double d){
    rot.y += d*rot_speed ;
    if( rot.y<  0.0 ) rot.y+=360.0 ;
    if( rot.y>360.0 ) rot.y-=360.0 ;
    return(rot.y) ;
  }

  double addRotZ(double d){
    rot.z += d*rot_speed ;
    if( rot.z<  0.0 ) rot.z+=360.0 ;
    if( rot.z>360.0 ) rot.z-=360.0 ;
    return(rot.z) ;
  }

  double addEyeZ(double d){
    eye.z += d*zoom_speed ;
    if( eye.z > 100.0 ) eye.z=100.0 ;
    if( eye.z <   0.5 ) eye.z=  0.5 ;
    return(eye.z) ;
  }

  int addShift(int x, int y, int prev_x, int prev_y){
    double dwin_w = cast(double)(win_w) ;
    double dwin_h = cast(double)(win_h) ;
    vec3D frcur, tocur ;
    tocur.set( eye.z*tan(fovy/2.0*PI/180.0) * (cast(double)(x) - (dwin_w/2.0))/(dwin_h/2.0) ,
	      -eye.z*tan(fovy/2.0*PI/180.0) * (cast(double)(y) - (dwin_h/2.0))/(dwin_h/2.0) ,
	       0.0) ;
    frcur.set( eye.z*tan(fovy/2.0*PI/180.0) * (cast(double)(prev_x) - (dwin_w/2.0))/(dwin_h/2.0) ,
	      -eye.z*tan(fovy/2.0*PI/180.0) * (cast(double)(prev_y) - (dwin_h/2.0))/(dwin_h/2.0) ,
	       0.0) ;
    pan += (tocur - frcur) ;
    return(0) ;
  }
  
  int calc(int x, int y, int prev_x, int prev_y){
    //視点の座標変換
    vec3D  xaxis ; xaxis.set(-1.0, 0.0, 0.0) ;
    vec3D  yaxis ; yaxis.set( 0.0,-1.0, 0.0) ;
    vec3D  zaxis ; zaxis.set( 0.0, 0.0,-1.0) ;

    geyepos = eye - pan ;
    geyepos = geyepos.rotate(rot.x*PI/180.0, xaxis) ;
    geyepos = geyepos.rotate(rot.y*PI/180.0, yaxis) ;
    geyepos = geyepos.rotate(rot.z*PI/180.0, zaxis) ;
    geyeray = geyepos ; geyeray=geyeray.normalize() ; geyeray=-geyeray ; //XYZ={0,0,0}を注目点とした時の視線

    double dwin_w = cast(double)(win_w) ;
    double dwin_h = cast(double)(win_h) ;
    vec3D frcur, tocur ;
    tocur.set( eye.z*tan(fovy/2.0*PI/180.0) * (cast(double)(x) - (dwin_w/2.0))/(dwin_h/2.0) ,
	      -eye.z*tan(fovy/2.0*PI/180.0) * (cast(double)(y) - (dwin_h/2.0))/(dwin_h/2.0) ,
	       0.0) ;
    frcur.set( eye.z*tan(fovy/2.0*PI/180.0) * (cast(double)(prev_x) - (dwin_w/2.0))/(dwin_h/2.0) ,
	      -eye.z*tan(fovy/2.0*PI/180.0) * (cast(double)(prev_y) - (dwin_h/2.0))/(dwin_h/2.0) ,
	       0.0) ;
    
    frcur-=pan ;
    frcur=frcur.rotate(rot.x*PI/180.0, xaxis) ;
    frcur=frcur.rotate(rot.y*PI/180.0, yaxis) ;
    frcur=frcur.rotate(rot.z*PI/180.0, zaxis) ;
    frray=frcur - geyepos ;
    tocur-=pan ;
    tocur=tocur.rotate(rot.x*PI/180.0, xaxis) ;
    tocur=tocur.rotate(rot.y*PI/180.0, yaxis) ;
    tocur=tocur.rotate(rot.z*PI/180.0, zaxis) ;
    toray=tocur - geyepos ;

    cursor3D = (toray.normalize() * 1.1) + geyepos ;
    
    return(0) ;
  }
  
}
    
