import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.WindowObject;
import win32frame.Split;
import win32frame.MsgBox;
import std.stdio;
import std.string;
import std.utf;

import OpenGLFrame ;
import OpPanel ;

class MainPanel : WindowObject {
  OpPanel     oppanel ;
  OpenGLFrame openglframe ;
  Split       splitbase ;

  this(string name, string ClassName) {
    winc.style          = 0;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.hIcon          = null ;
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)) ;
    winc.lpszMenuName   = null;
    winc.lpszClassName  = toUTFz!(wchar*)(ClassName) ;
    super(name) ;
    this.registwinc() ;
  }

  override LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      break ;
      
    case WM_CREATE:
      splitbase = new Split("SplitBase") ;
      splitbase.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      splitbase.setPosition(0,0,256,256) ;
      splitbase.setSashPos(144,0,144) ;
      addObject( splitbase, cast(HMENU)(0), true, true) ;
      
      oppanel = new OpPanel("OpPanel","OpPanel") ;
      oppanel.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      oppanel.setPosition(0,0,256,256) ;
      splitbase.addObject(oppanel, cast(HMENU)(0)) ;
      
      openglframe = new OpenGLFrame("OpenGLFrame","OpenGLFrame") ;
      openglframe.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      openglframe.setPosition(0,0,256,256) ;
      splitbase.addObject(openglframe, cast(HMENU)(0)) ;

      break ;
      
    case WM_PAINT:
      PAINTSTRUCT ps ;
      HDC         hdc;
      hdc=BeginPaint(hwnd, &ps);
      EndPaint(hwnd, &ps);
      break ;
      
    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }

}
