import win32.windows;
import win32frame.WindowObject ;
import std.string;
import std.stdio;
import std.utf;

COLORREF RGB(uint r, uint g, uint b) {
  return cast(COLORREF)(r | (g << 8) | (b << 16));
}

class MyStaticCtl : WindowObject {
  HFONT    labelfont ;
  uint     strcol ;

  this(string name) {
    winc.style          = 0;
    this.setStyle(WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE) ;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.lpszMenuName   = null;
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_3DFACE)) ;
    winc.lpszClassName  = toUTFz!(wchar*)("MyStaticCtl") ;
    super(name) ;
    this.registwinc() ;
  }

  override int setFont(HFONT hfont){
    this.labelfont=hfont ;
    if( getHWND()!=null ){
      InvalidateRect(getHWND() , null , true);
    }
    return(0) ;
  }

  uint setStringColor(int r, int g, int b){
    uint oldcol=strcol ;
    strcol=RGB(r,g,b) ;
    if( getHWND()!=null ){
      InvalidateRect(getHWND() , null , true);
    }
    return(oldcol) ;
  }

  uint setStringColor(uint color){
    uint oldcol=strcol ;
    strcol=color ;
    if( getHWND()!=null ){
      InvalidateRect(getHWND() , null , true);
    }
    return(oldcol) ;
  }

  override LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch( msg ){    
    case WM_PAINT:
      PAINTSTRUCT ps ;
      HBRUSH  COLBASE ;
      uint    bgcol ;

      HDC hdc = BeginPaint(hwnd, &ps);
      SetBkMode(hdc , TRANSPARENT);

      bgcol     = GetSysColor(COLOR_3DFACE) ;
      COLBASE   = CreateSolidBrush(bgcol) ;
      RECT rc ;
      GetClientRect( hwnd, &rc ) ;
      FillRect(hdc, &rc, COLBASE) ;

      SIZE labelsize ;
      wchar[] label=(toUTF16(getWindowText())).dup ;
      SelectObject(hdc,labelfont) ;
      SetTextColor(hdc,strcol) ;
      GetTextExtentPoint32(hdc , cast(wchar*)(label) , cast(int)(label.length) , &labelsize);
      int px = (this.style & BS_CENTER )==BS_CENTER  ? (winW-labelsize.cx)/2+1 : (this.style & BS_RIGHT )==BS_RIGHT ? (winW-labelsize.cx) : 3 ;
      int py = (this.style & BS_VCENTER)==BS_VCENTER ? (winH-labelsize.cy)/2+1 : (this.style & BS_BOTTOM)==BS_BOTTOM? (winH-labelsize.cy) : 3 ;
      TextOut(hdc,px,py,cast(wchar*)(label), cast(int)(label.length)) ;
      EndPaint(hwnd, &ps);
      
      DeleteObject(COLBASE ) ;
      break ;
      
    default : break ;
    }
    return( DefWindowProc(hwnd , msg , wp , lp) ) ;
  }
  
}
