import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.DialogBoxClass;
import win32frame.PushButton;
import win32frame.TextBox;
import util.BitMap;
import std.stdio;
import std.string;
import std.utf;
import std.math;

import Spin;
import MyButton ;
import ColorSelectDialog;

import WorkSpace ;

COLORREF RGB(uint r, uint g, uint b) {
  return cast(COLORREF)(r | (g << 8) | (b << 16));
}
COLORREF RGBA(uint r, uint g, uint b, uint a) {
  return cast(COLORREF)(r | (g << 8) | (b << 16) | (a<<24));
}

enum CMD{
  OK = 0x100
} ;

class OpHelpDialog : DialogBoxClass {
  PushButton   buttonOK  ;
  HFONT        hfont  ;
  int          dlgstate  ;

  const DWORD  defaultStyle = WS_VISIBLE | WS_SYSMENU ;
  string[]     helpstr ;

  this(string name, string ClassName) {
    UnregisterClass( toUTFz!(wchar*)(ClassName), GetModuleHandle(null) ) ;
    winc.cbSize         = WNDCLASSEX.sizeof;
    winc.style          = 0;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.hIcon          = null ;
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)) ;
    winc.lpszMenuName   = null;
    winc.lpszClassName  = toUTFz!(wchar*)(ClassName) ;
    super(name) ;
  }

  int Create( int x, int y, int w, int h, HWND phwnd, HMENU hmenu){
    return( create(defaultStyle,x,y,w,h,phwnd,hmenu) ) ;
  }
  
  override LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      DeleteObject(hfont);
      break ;
    case WM_CREATE:
      hfont = CreateFont(
			 12 , 0 , 0 , 0 , FW_REGULAR , FALSE , FALSE , FALSE ,
			 DEFAULT_CHARSET, OUT_DEFAULT_PRECIS ,
			 CLIP_DEFAULT_PRECIS , DEFAULT_QUALITY , 
			 FIXED_PITCH, null
			 );

      buttonOK= new PushButton("OK") ;
      buttonOK.addStyle(WS_TABSTOP) ;
      buttonOK.setPosition((winW-80)/2,winH-32,80,20) ;
      addObject( buttonOK, cast(HMENU)(CMD.OK) ) ;
      buttonOK.setFont(hfont) ;

      break ;
      
    case WM_PAINT:
      PAINTSTRUCT ps;
      HBRUSH  BGCOL=CreateSolidBrush(GetSysColor(COLOR_3DFACE)) ;
      RECT rc ;
      GetClientRect( hwnd, &rc ) ;
      
      HDC hdc = BeginPaint(hwnd, &ps);
      FillRect(hdc, &rc, BGCOL) ;
      SetBkMode(hdc , TRANSPARENT);
      int y=16 ;
      foreach( i, str ; helpstr){
	SIZE wstrsize ;
	wchar[] wstr=(toUTF16(str)).dup ;
	SelectObject(hdc,hfont) ;
	GetTextExtentPoint32( hdc, cast(wchar*)(wstr), cast(int)(wstr.length), &wstrsize);
	TextOut(hdc, (winW-wstrsize.cx)/2,y, cast(wchar*)(wstr), cast(int)(wstr.length)) ;
	y+=wstrsize.cy ;
      }
      EndPaint(hwnd, &ps);
      DeleteObject(BGCOL) ;
      break ;
      
    case WM_SIZE:
      MoveWindow( buttonOK.getHWND(), (winW-80)/2,winH-32,80,20, true ) ;
      RedrawWindow(hwnd, null, null, RDW_INVALIDATE) ;
      break ;
      
    case WM_CLOSE:
      setResult(0) ;
      DestroyWindow(hwnd);
      break ;
      
    case WM_COMMAND:
      dlgstate=LOWORD(wp) ;
      switch( dlgstate ){
      case CMD.OK:
        setResult(1) ;
        DestroyWindow(hwnd);
        break ;
	
      default :
	break ;
      }
      break ;
      
    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }

  void setHelpString(string[] helpstr){
    this.helpstr.length = helpstr.length ;
    this.helpstr[]=helpstr[] ;
  }

}
  
