import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.DialogBoxClass;
import win32frame.PushButton;
import win32frame.TextBox;
import std.stdio;
import std.string;
import std.utf;

enum CMD{
  TXTBOX = 0x100,
  OK     ,
  CANCEL
} ;

class TextEditDialog : DialogBoxClass {
  TextBox     textbox ;
  PushButton  buttonOK  ;
  PushButton  buttonCAN ;
  HFONT       hfont  ;

  string      defaulttext ;
  string      resulttext ;
  int         dlgstate ;

  const int   defaultWidth =200 ;
  const int   defaultHeight=100 ;
  const DWORD defaultStyle = WS_VISIBLE | WS_SYSMENU ;

  this(string name, string ClassName) {
    UnregisterClass( toUTFz!(wchar*)(ClassName), GetModuleHandle(null) ) ;
    winc.cbSize         = WNDCLASSEX.sizeof;
    winc.style          = 0;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.hIcon          = null ;
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)) ;
    winc.lpszMenuName   = null;
    winc.lpszClassName  = toUTFz!(wchar*)(ClassName) ;
    super(name) ;
  }

  int Create( int x, int y, HWND phwnd, HMENU hmenu){
    return( create(defaultStyle,x,y,defaultWidth,defaultHeight,phwnd,hmenu) ) ;
  }
  
  int Create( int x, int y, int w, int h, HWND phwnd, HMENU hmenu){
    return( create(defaultStyle,x,y,w,h,phwnd,hmenu) ) ;
  }
  
  override LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      DeleteObject(hfont);
      break ;
    case WM_CREATE:
      hfont = CreateFont(
			 12 , 0 , 0 , 0 , FW_REGULAR , FALSE , FALSE , FALSE ,
			 DEFAULT_CHARSET, OUT_DEFAULT_PRECIS ,
			 CLIP_DEFAULT_PRECIS , DEFAULT_QUALITY , 
			 FIXED_PITCH, null
			 );
      
      textbox = new TextBox(defaulttext) ;
      textbox.addExStyle(WS_EX_CLIENTEDGE) ;
      textbox.addStyle(WS_BORDER | ES_LEFT | ES_AUTOHSCROLL | WS_TABSTOP) ;
      textbox.setPosition(8,8,winW-16,20) ;
      addObject(textbox, cast(HMENU)(CMD.TXTBOX), false, false) ;
      textbox.setFont(hfont) ;

      buttonOK= new PushButton("OK") ;
      buttonOK.addStyle(WS_TABSTOP) ;
      buttonOK.setPosition(winW-184,winH-32,80,20) ;
      addObject( buttonOK, cast(HMENU)(CMD.OK) ) ;
      buttonOK.setFont(hfont) ;

      buttonCAN= new PushButton("Cancel") ;
      buttonCAN.addStyle(WS_TABSTOP) ;
      buttonCAN.setPosition(winW-92,winH-32,80,20) ;
      addObject( buttonCAN, cast(HMENU)(CMD.CANCEL) ) ;
      buttonCAN.setFont(hfont) ;

      SetFocus(textbox.getHWND()) ;

      break ;
      
    case WM_PAINT:
      PAINTSTRUCT ps;
      HDC hdc;
      hdc = BeginPaint(hwnd, &ps);
      EndPaint(hwnd, &ps);
      break ;
      
    case WM_SIZE:
      break ;
      
    case WM_CLOSE:
      setResult(0) ;
      DestroyWindow(hwnd);
      break ;
      
    case WM_COMMAND:
      dlgstate=LOWORD(wp) ;
      switch( dlgstate ){
      case CMD.CANCEL:
        setResult(0) ;
        DestroyWindow(hwnd);
        break ;
      case CMD.OK:
        setResult(1) ;
	resulttext = textbox.getWindowText() ;
        DestroyWindow(hwnd);
        break ;
      case CMD.TXTBOX :
	break ;
      default :
	break ;
      }
      break ;
      
    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }

  int setDefaultText(string text){
    defaulttext = text ;
    return(0) ;
  }
  
  string getText(){
    return(resulttext) ;
  }

}
  
