import win32.windows;
import win32.windef;
import win32.commctrl;

import std.stdio;
import std.string;
import std.utf;
import std.file;

//
// Example:
//  string fname ;
//  fname = getLoadFileName("WaveFrontOBJ {*.obj}\0*.obj\0",parentHWND,OFN_HIDEREADONLY) ;
//

class FileDialog{

  this(){
  }

  string getSaveFileName(string filematch, HWND parentHWND, DWORD addflags=0, string initfn=""){
    OPENFILENAME ofn ;
    wchar[]      wfname ;
    string       retstr="" ;
    string       curdir=std.file.getcwd() ;

    wfname.length=MAX_PATH ;
    wfname[]=0 ;
    if( initfn != "" ){
      wchar* pfn=toUTFz!(wchar*)(initfn) ;
      for( int i=0 ; i<MAX_PATH-1 ; i++ ){
	if( pfn[i]=='\0' ) break ;
	wfname[i]=pfn[i] ;
      }
    }
    
    ofn.lStructSize = OPENFILENAME.sizeof ;
    ofn.hwndOwner   = parentHWND ;
    if( filematch==null ){
      ofn.lpstrFilter = null ;
    }else{
      ofn.lpstrFilter = toUTFz!(wchar*)(filematch) ;
    }
    ofn.lpstrCustomFilter = null ;
    ofn.lpstrFile   = wfname.ptr ;
    ofn.nMaxFile    = MAX_PATH ;
    ofn.Flags       = addflags ;

    int rc = GetSaveFileName(&ofn) ;

    if( rc!=0 ){
      foreach( i, c ; wfname ){
	if( c==0 ){ wfname.length=i ; break ; }
      }
      retstr = std.utf.toUTF8(wfname.idup) ;
    }

    std.file.chdir(curdir) ;
    
    return(retstr) ;
  }
  

  string getLoadFileName(string filematch, HWND parentHWND, DWORD addflags=0){
    OPENFILENAME ofn ;
    wchar[]      wfname ;
    string       retstr ;
    string       curdir=std.file.getcwd() ;

    wfname.length=MAX_PATH ;
    wfname[]=0 ;

    ofn.lStructSize = OPENFILENAME.sizeof ;
    ofn.hwndOwner   = parentHWND ;
    if( filematch==null ){
      ofn.lpstrFilter = null ;
    }else{
      ofn.lpstrFilter = toUTFz!(wchar*)(filematch) ;
    }
    ofn.lpstrCustomFilter = null ;
    ofn.lpstrFile   = wfname.ptr ;
    ofn.nMaxFile    = MAX_PATH ;
    ofn.Flags       = OFN_FILEMUSTEXIST | addflags ;

    int rc=GetOpenFileName(&ofn) ;

    if( rc!=0 ){
      foreach( i, c ; wfname ){
	if( c==0 ){ wfname.length=i ; break ;}
      }
      retstr = std.utf.toUTF8(wfname.idup) ;
    }
    
    std.file.chdir(curdir) ;
    
    return(retstr) ;
  }
}  
